//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.dll;
//using Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//using Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;

using System;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using System.Diagnostics;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;


namespace AddUpdateScript
{
    class AddUpdateScript
    {
         static string CONNECTION_STRING = "Server=WIN-PSNJDGP2C9B;CompanyDB=SBODemo_US_43;ExtraDb=PMX_SBODemo_US_43;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2012;DBCultureInfo=en-US;LicenseServer=WIN-PSNJDGP2C9B:30000";
		//static string CONNECTION_STRING = "Server=WIN-PSNJDGP2C9B;CompanyDB=SBODemo_US;ExtraDb=PMX_SBODemo_US;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2012;DBCultureInfo=en-US;LicenseServer=WIN-PSNJDGP2C9B:30000";
        static string SCRIPT_ROOT = @"..\..\WorkflowScripts";

        /// <summary>
        /// Used for logging
        /// </summary>
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

        static void Main(string[] args)
        {
            string test = SCRIPT_ROOT;
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
				using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);

                    // Add UDF to Business Partners
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("CustNum", "Klantennummer", SboFieldType.Alpha, 10, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("DelDay2", "2de leveringsdag", SboFieldType.Alpha, 10, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("PrefCom", "Communicatie via", SboFieldType.Alpha, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("Acquaint", "Leren kennen via", SboFieldType.Alpha, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("PrefCom", "Communicatie via", SboFieldType.Alpha, 8, SboFieldSubType.None));


                    // End adding UDF to Business Partners

                    // start adding UDF to item master Data

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL1", "Titel facturatiebijlage 1", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL2", "Titel facturatiebijlage 2", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL3", "Titel facturatiebijlage 3", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL4", "Titel facturatiebijlage 4", SboFieldType.Memo, 8, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg1", "Titel legpatroon 1", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg2", "Titel legpatroon 2", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg3", "Titel legpatroon 3", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg4", "Titel legpatroon 4", SboFieldType.Memo, 8, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("VastOpm", "Vaste opmerking per artikel", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Hardheid", "Hardheid", SboFieldType.Alpha, 20, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact1", "Bijlage bij factuur 1", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact2", "Bijlage bij factuur 2", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact3", "Bijlage bij factuur 3", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact4", "Bijlage bij factuur 4", SboFieldType.Memo, 250, SboFieldSubType.Link));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat1", "Legpatroon 1", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat2", "Legpatroon 2", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat3", "Legpatroon 3", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat4", "Legpatroon 4", SboFieldType.Memo, 250, SboFieldSubType.Link));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("OrgArt", "Oorspronkelijk artikelnummer", SboFieldType.Alpha, 20, SboFieldSubType.None));
                    //dit is om de controle uit te voeren als origineel artikelcode is aangepast
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("OrgArtC", "Oorspronkelijk artikelnummer (controle)", SboFieldType.Alpha, 20, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs1", "Prijs 1 - Aanb vkp ex btw", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs2", "Prijs 2 - Geaff tnz ex btw ", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs3", "Prijs 3 - Net ikp ex btw", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs4", "Prijs 4 – Beursprijs", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5", "Prijs 5 - Soldenprijs", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LastPric", "Laatste aankoopprijs", SboFieldType.Float, 4, SboFieldSubType.Price));


                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LocToon", "Locatie Toonzaal", SboFieldType.Alpha, 30, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LocSample", "Locatie stalen", SboFieldType.Alpha, 30, SboFieldSubType.None));


                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("OrgArtOk", "Origineel art", SboFieldType.Alpha, 1, SboFieldSubType.None));


                    SboColumnDefinitionAttribute OrgArtOK = new SboColumnDefinitionAttribute("OrgArtOk", "Origineel Artikel Check", SboFieldType.Alpha, 1, SboFieldSubType.None);
                    // boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
                    OrgArtOK.DefaultValue = "1";
                    udfProv.AddUpdateUserfield("OITM", OrgArtOK);

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LastDat", "Prijs 1 - Laatste aankoopdatum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs1Date", "Prijs 1 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs2Date", "Prijs 2 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs3Date", "Prijs 3 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs4Date", "Prijs 4 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5Date", "Prijs 5 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5DateF", "Prijs 5 - geldig vanaf", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5DateT", "Prijs 5 - geldig tot", SboFieldType.Date, 4, SboFieldSubType.None));


					//Update default value to 'N' 
					SboColumnDefinitionAttribute colDef = new SboColumnDefinitionAttribute(Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.AllowMultipleBatches.NAME,
						Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.AllowMultipleBatches.DESCR,
						Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.AllowMultipleBatches.TYPE,
						Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.AllowMultipleBatches.SIZE,
						Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables.PmxDocumentLineColumns.AllowMultipleBatches.SUB_TYPE);
					colDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					colDef.DefaultValue = SboBooleanColumnValues.N.VALUE;
					udfProv.AddUpdateUserfield(PmxSalesOrderLineTable.NAME, colDef);




                    // End adding UDF to item master data

                    // Start adding UDF to document headers
                    udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("plandate", "Vast afgespr lev-afh datum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("estdate", "Geschatte leveringdatum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("OpItms", "Document print", SboFieldType.Numeric, 1, SboFieldSubType.None));
		    		udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("Payadva", "Betaald voorschot", SboFieldType.Float, 1, SboFieldSubType.Price));
	

                    // End adding UDF to document headers


                    // Start adding UDF to document lines

                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("BvAantal", "Bevestigd aantal", SboFieldType.Float, 1, SboFieldSubType.Quantity));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("BvNum", "Bevestigingsnummer", SboFieldType.Numeric, 10, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("BvDat", "Bevestigingsdatum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("ppvkpe", "prijs per verkoopeenheid", SboFieldType.Float, 4, SboFieldSubType.Sum));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("SecOms", "Tweede omschrijving", SboFieldType.Alpha, 50, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("stocksu", "Stock in vkeh", SboFieldType.Float, 1, SboFieldSubType.Quantity));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("OrgArt", "Oud artikelnummer", SboFieldType.Alpha, 20, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("GLLOCALNAME", "Grootboek Naam", SboFieldType.Alpha, 100, SboFieldSubType.None));



                    // End adding UDF to document lines


                    //Add culture name to user language
                    //     udfProv.AddUpdateUserfield("OLNG", new SboColumnDefinitionAttribute("PMX_CULT", "Culture name", SboFieldType.Alpha, 20, SboFieldSubType.None));

                    //Add automatic shipping to Shipping types
                    //  SboColumnDefinitionAttribute boolColumnDef = new SboColumnDefinitionAttribute("PMX_AUSH", "Automatic shipping?", SboFieldType.Alpha, 1, SboFieldSubType.None);
                    //  boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
                    //  boolColumnDef.DefaultValue = "N";
                    //  udfProv.AddUpdateUserfield("OSHP", boolColumnDef);

                }
			
               // using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                  //  dbConn.Open(); //Open connection to SAP
                    //Console.WriteLine("Connection is open to database");

                    //Console.WriteLine("Workflows");

                    //Console.WriteLine("Extensions");

                  //  Console.WriteLine("Workflows");
                   // AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.SUB_FLOW, "ImpermoCountLogisticUnitsScript",
                     //   SCRIPT_ROOT + @"\WorkflowScript_ImpermoCountLogisticUnitsScript\WorkflowScript_ImpermoCountLogisticUnitsScript.cs", dbConn);

                    //AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.SUB_FLOW, "ImpermoScanSSCCOnLocationScript",
                      //  SCRIPT_ROOT + @"\WorkflowScript_ImpermoScanSSCCOnLocationScript\WorkflowScript_ImpermoScanSSCCOnLocationScript.cs", dbConn);             
                }
                //Complete transaction
                scope.Complete();
            }




            Console.WriteLine("Done ...");
        }

        ///// <summary>
        ///// Runs the table SQL script.
        ///// </summary>
        ///// <param name="tableScript">The table script.</param>
        ///// <param name="conn">The conn.</param>
        //private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
        //{
        //    string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.NGK.SboCommands)), "Produmex.Sbo.Logex.NGK.Scripts.Tables." + tableScript);
        //    SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        //}

        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnectionSql conn)
        {
            PmxExtensionProvider prov = new PmxExtensionProvider(conn);
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO(code);
                if (extension == null)
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
                if (newBO)
                {
                    prov.AddBO(extension);
                }
                else
                {
                    prov.UpdateBO(extension, false, false);
                }
            }
            finally
            {
                if (extension != null) extension.Dispose();
            }
        }

        


        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }



        }
    }
}
