IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PMX_SP_IMP_PickList]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[PMX_SP_IMP_PickList]
GO

-- =============================================
-- Author:		Produmex
-- Create date: 
-- Description:	Impermo pick list document
-- =============================================
CREATE PROCEDURE [dbo].[PMX_SP_IMP_PickList] 
	-- Parameters for the stored procedure
	@pickListDocEntry int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	SELECT     dbo.PMX_PLHE.DocEntry, dbo.PMX_PLHE.CardCode, dbo.PMX_PLHE.CardName, dbo.PMX_PLHE.ShipToAddress, PMX_OSEL_1.Name AS Dock, 
						  dbo.PMX_PLHE.DueDate, dbo.PMX_PLHE.Priority, dbo.PMX_PLHE.PickPackRemarks, dbo.PMX_PLLI.ItemCode, dbo.PMX_PLLI.Dscription, 
						  dbo.PMX_PLLI.Quantity, dbo.PMX_PLLI.Uom, 
						  dbo.PMX_OSSL.Name AS PickLocation, ISNULL(OSHP_RDR1.TrnspName, OSHP_INV1.TrnspName) AS Transport, ISNULL(OCRD.Phone1, OCRD.Phone2) AS Phone,
							OCRD.E_Mail, OCRD.LicTradNum, dbo.PMX_FN_GetPackagingTypesText(PMX_PLLI.ItemCode, PMX_PLLI.ItemTransactionalInfoKey, PMX_PLLI.Quantity, 'B') AS PackagingTypes, 
					OITM.U_OrgArt AS OrigineelArtikelNummer, ISNULL(INV1.U_SecOms,RDR1.U_SecOms)  AS Omschrijving2, OITM.U_PMX_VIDE AS LeveranciersOmschrijving,
					ISNULL(OUSR.U_Name, ISNULL(OSLP_RDR1.SlpName, OSLP_INV1.SlpName)) AS VerkopersNaam, ISNULL(OUSR.E_Mail, ISNULL(OSLP_RDR1.Memo, OSLP_INV1.Memo)) AS VerkoperEmail,
					ISNULL(ORDR.DocDueDate, OINV.DocDueDate) AS VervalDatum, ISNULL(ORDR.U_EstDate, OINV.U_EstDate) AS GeschLevDatum, ISNULL(ORDR.U_PlanDate, OINV.U_PlanDate) AS VastAfgesprDatum,
					ISNULL( OCRD_RDR1.CardName, OCRD_INV1.CardName) AS ZPKanaal, ISNULL( ORDR.DocTotal, OINV.DocTotal) AS DocTotal, ISNULL( ORDR.PaidSum, OINV.PaidSum) AS Paid, ISNULL( ORDR.DocEntry, OINV.DocEntry) AS SalesDocEntry,
					OITM.SWeight1 AS Weight, ISNULL(NULLIF(OITM.U_PMX_DQU2, 0),1) AS Sleutelveld, ISNULL(dbo.OITM.U_PMX_UOM2,dbo.PMX_PLLI.Uom)  AS Uom2, OWGT.UnitDisply, ISNULL(ORDR.Comments, OINV.Comments) AS OpmerkingOpOrder, ISNULL(RDR1.U_PMX_QTY2, INV1.U_PMX_QTY2) AS QuantityUom2, PMX_PLPH.Remarks AS RemarksOnProposal,
					dbo.PMX_FN_GetAllLocationsForItemForAdHocPicking(PMX_OSEL_1.PmxWhsCode, PMX_PLLI.ItemCode, dbo.PMX_FN_GetBatchToPickForAdHocPicking(PMX_PLHE.DocEntry, PMX_PLLI.ItemCode), ', ') AS Locations
	FROM         dbo.PMX_PLHE INNER JOIN
						  dbo.PMX_PLLI ON dbo.PMX_PLHE.DocEntry = dbo.PMX_PLLI.DocEntry INNER JOIN
							OITM ON PMX_PLLI.ItemCode = OITM.ItemCode INNER JOIN
						OCRD ON OCRD.CardCode = PMX_PLHE.CardCode INNER JOIN
						  dbo.PMX_OSEL AS PMX_OSEL_1 ON dbo.PMX_PLHE.DestStorLocCode = PMX_OSEL_1.Code INNER JOIN
                      dbo.PMX_PLPL ON dbo.PMX_PLLI.BaseEntry = dbo.PMX_PLPL.DocEntry AND dbo.PMX_PLLI.BaseLine = dbo.PMX_PLPL.LineNum 
						INNER JOIN PMX_PLPH ON PMX_PLPL.DocEntry = PMX_PLPH.DocEntry
        					INNER JOIN OUSR ON PMX_PLPH.UserSign = OUSR.Internal_K LEFT JOIN
						dbo.OWGT ON OWGT.UnitCode = OITM.SWght1Unit LEFT JOIN
						  --Join order
							dbo.RDR1 ON dbo.PMX_PLPL.BaseLine = dbo.RDR1.LineNum AND dbo.PMX_PLPL.BaseEntry = dbo.RDR1.DocEntry AND 
						  dbo.PMX_PLPL.BaseType = dbo.RDR1.ObjType LEFT JOIN
						  ORDR ON ORDR.DocEntry = RDR1.DocEntry LEFT OUTER JOIN
							--Join Invoice
						  dbo.INV1 ON dbo.PMX_PLPL.BaseLine = dbo.INV1.LineNum AND dbo.PMX_PLPL.BaseEntry = dbo.INV1.DocEntry AND 
						  dbo.PMX_PLPL.BaseType = dbo.INV1.ObjType LEFT JOIN
						  OINV ON OINV.DocEntry = INV1.DocEntry 
							LEFT JOIN OSHP AS OSHP_RDR1 ON OSHP_RDR1.TrnspCode = RDR1.TrnsCode
							LEFT JOIN OSHP AS OSHP_INV1 ON OSHP_INV1.TrnspCode = INV1.TrnsCode
							LEFT JOIN OSLP AS OSLP_RDR1 ON OSLP_RDR1.SlpCode = RDR1.SlpCode
							LEFT JOIN OSLP AS OSLP_INV1 ON OSLP_INV1.SlpCode = INV1.SlpCode
							LEFT JOIN OCRD AS OCRD_RDR1 ON OCRD_RDR1.CardCode = ORDR.BPChCode
							LEFT JOIN OCRD AS OCRD_INV1 ON OCRD_INV1.CardCode = OINV.BPChCode

							LEFT OUTER JOIN
						  dbo.PMX_OSSL ON dbo.PMX_PLLI.StorLocCode = dbo.PMX_OSSL.Code LEFT OUTER JOIN
						  dbo.PMX_ITRI ON dbo.PMX_PLLI.ItemTransactionalInfoKey = dbo.PMX_ITRI.InternalKey
	WHERE dbo.PMX_PLHE.DocEntry = @pickListDocEntry
	AND dbo.PMX_PLLI.LineStatus NOT IN ('C', 'F')
	ORDER BY 					
	dbo.PMX_FN_GetFirstSequenceForLocationsForItemForAdHocPicking(PMX_OSEL_1.PmxWhsCode, PMX_PLLI.ItemCode, dbo.PMX_FN_GetBatchToPickForAdHocPicking(PMX_PLHE.DocEntry, PMX_PLLI.ItemCode)),
	PMX_PLLI.ItemCode


	
END
